'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * spoonacular API
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * The spoonacular Nutrition, Recipe, and Food API allows you to access over 380,000 recipes, thousands of ingredients, 80,000 food products, and 100,000 menu items. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * The version of the OpenAPI document: 1.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Contact: david@spoonacular.com
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * https://openapi-generator.tech
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Do not edit the class manually.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _ApiClient = require('../ApiClient');

var _ApiClient2 = _interopRequireDefault(_ApiClient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * The InlineObject3 model module.
 * @module com.spoonacular.client/com.spoonacular.client.model/InlineObject3
 * @version 1.0
 */
var InlineObject3 = function () {
  /**
   * Constructs a new <code>InlineObject3</code>.
   * @alias module:com.spoonacular.client/com.spoonacular.client.model/InlineObject3
   * @param title {String} The title of the recipe.
   * @param image {File} The binary image of the recipe as jpg.
   * @param ingredients {String} The ingredient list of the recipe, one ingredient per line (separate lines with \\n).
   * @param instructions {String} The instructions to make the recipe. One step per line (separate lines with \\n).
   * @param readyInMinutes {Number} The number of minutes it takes to get the recipe on the table.
   * @param servings {Number} The number of servings that you can make from the ingredients.
   * @param mask {String} The mask to put over the recipe image (\"ellipseMask\", \"diamondMask\", \"diamondMask\", \"starMask\", \"heartMask\", \"potMask\", \"fishMask\").
   * @param backgroundImage {String} The background image (\"none\",\"background1\", or \"background2\").
   */
  function InlineObject3(title, image, ingredients, instructions, readyInMinutes, servings, mask, backgroundImage) {
    _classCallCheck(this, InlineObject3);

    InlineObject3.initialize(this, title, image, ingredients, instructions, readyInMinutes, servings, mask, backgroundImage);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(InlineObject3, null, [{
    key: 'initialize',
    value: function initialize(obj, title, image, ingredients, instructions, readyInMinutes, servings, mask, backgroundImage) {
      obj['title'] = title;
      obj['image'] = image;
      obj['ingredients'] = ingredients;
      obj['instructions'] = instructions;
      obj['readyInMinutes'] = readyInMinutes;
      obj['servings'] = servings;
      obj['mask'] = mask;
      obj['backgroundImage'] = backgroundImage;
    }

    /**
     * Constructs a <code>InlineObject3</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:com.spoonacular.client/com.spoonacular.client.model/InlineObject3} obj Optional instance to populate.
     * @return {module:com.spoonacular.client/com.spoonacular.client.model/InlineObject3} The populated <code>InlineObject3</code> instance.
     */

  }, {
    key: 'constructFromObject',
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new InlineObject3();

        if (data.hasOwnProperty('title')) {
          obj['title'] = _ApiClient2.default.convertToType(data['title'], 'String');
        }
        if (data.hasOwnProperty('image')) {
          obj['image'] = _ApiClient2.default.convertToType(data['image'], File);
        }
        if (data.hasOwnProperty('ingredients')) {
          obj['ingredients'] = _ApiClient2.default.convertToType(data['ingredients'], 'String');
        }
        if (data.hasOwnProperty('instructions')) {
          obj['instructions'] = _ApiClient2.default.convertToType(data['instructions'], 'String');
        }
        if (data.hasOwnProperty('readyInMinutes')) {
          obj['readyInMinutes'] = _ApiClient2.default.convertToType(data['readyInMinutes'], 'Number');
        }
        if (data.hasOwnProperty('servings')) {
          obj['servings'] = _ApiClient2.default.convertToType(data['servings'], 'Number');
        }
        if (data.hasOwnProperty('mask')) {
          obj['mask'] = _ApiClient2.default.convertToType(data['mask'], 'String');
        }
        if (data.hasOwnProperty('backgroundImage')) {
          obj['backgroundImage'] = _ApiClient2.default.convertToType(data['backgroundImage'], 'String');
        }
        if (data.hasOwnProperty('author')) {
          obj['author'] = _ApiClient2.default.convertToType(data['author'], 'String');
        }
        if (data.hasOwnProperty('backgroundColor')) {
          obj['backgroundColor'] = _ApiClient2.default.convertToType(data['backgroundColor'], 'String');
        }
        if (data.hasOwnProperty('fontColor')) {
          obj['fontColor'] = _ApiClient2.default.convertToType(data['fontColor'], 'String');
        }
        if (data.hasOwnProperty('source')) {
          obj['source'] = _ApiClient2.default.convertToType(data['source'], 'String');
        }
      }
      return obj;
    }
  }]);

  return InlineObject3;
}();

/**
 * The title of the recipe.
 * @member {String} title
 */


InlineObject3.prototype['title'] = undefined;

/**
 * The binary image of the recipe as jpg.
 * @member {File} image
 */
InlineObject3.prototype['image'] = undefined;

/**
 * The ingredient list of the recipe, one ingredient per line (separate lines with \\n).
 * @member {String} ingredients
 */
InlineObject3.prototype['ingredients'] = undefined;

/**
 * The instructions to make the recipe. One step per line (separate lines with \\n).
 * @member {String} instructions
 */
InlineObject3.prototype['instructions'] = undefined;

/**
 * The number of minutes it takes to get the recipe on the table.
 * @member {Number} readyInMinutes
 */
InlineObject3.prototype['readyInMinutes'] = undefined;

/**
 * The number of servings that you can make from the ingredients.
 * @member {Number} servings
 */
InlineObject3.prototype['servings'] = undefined;

/**
 * The mask to put over the recipe image (\"ellipseMask\", \"diamondMask\", \"diamondMask\", \"starMask\", \"heartMask\", \"potMask\", \"fishMask\").
 * @member {String} mask
 */
InlineObject3.prototype['mask'] = undefined;

/**
 * The background image (\"none\",\"background1\", or \"background2\").
 * @member {String} backgroundImage
 */
InlineObject3.prototype['backgroundImage'] = undefined;

/**
 * The author of the recipe.
 * @member {String} author
 */
InlineObject3.prototype['author'] = undefined;

/**
 * The background color on the recipe card as a hex-string.
 * @member {String} backgroundColor
 */
InlineObject3.prototype['backgroundColor'] = undefined;

/**
 * The font color on the recipe card as a hex-string.
 * @member {String} fontColor
 */
InlineObject3.prototype['fontColor'] = undefined;

/**
 * The source of the recipe.
 * @member {String} source
 */
InlineObject3.prototype['source'] = undefined;

exports.default = InlineObject3;